message("FindOpenBLAS starting...")

set(OpenBLAS_ROOT external_dependencies/OpenBLAS)

FIND_PATH(
    OpenBLAS_INCLUDE_DIR

    NAMES
    cblas.h

    HINTS
        ${OpenBLAS_INCLUDE_DIRECTORY}
        $ENV{OpenBLAS_INCLUDE_DIRECTORY}
        /usr/include/
        /usr/include/x86_64-linux-gnu
        external_dependencies/OpenBLAS
)

FIND_LIBRARY(OpenBLAS_LIBRARIES
    NAMES
    ${LIB_PREFIX}openblas.${LIB_SUFFIX}

    HINTS
    ${OpenBLAS_LIBRARY_DIRECTORY}
    $ENV{OpenBLAS_LIBRARY_DIRECTORY}
    /usr/lib
    /usr/lib/x86_64-linux-gnu
    external_dependencies/OpenBLAS/lib
)

# Set OpenBLAS_Found
INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(
        OpenBLAS

        FAIL_MESSAGE
            "OpenBLAS was NOT found!"

        REQUIRED_VARS
            OpenBLAS_INCLUDE_DIR
            OpenBLAS_LIBRARIES
)

IF (OpenBLAS_FOUND)
   MESSAGE(STATUS "Found OpenBLAS libraries: ${OpenBLAS_LIBRARIES}")
   MESSAGE(STATUS "Found OpenBLAS include: ${OpenBLAS_INCLUDE_DIR}")
 ELSE()
    MESSAGE("Could not find OpenBLAS")
ENDIF()
